import { sel, createColor } from "polythene-core-css";

const generalFns = ({
  general_styles: selector => [], // eslint-disable-line no-unused-vars
});

const tintFns = tint => ({
  ["color_" + tint + "_text"]: (selector, vars) => [
    sel(selector, {
      color: vars["color_" + tint + "_text"],  
    })
  ],
  ["color_" + tint + "_background"]: (selector, vars) => [
    sel(selector, {
      backgroundColor: vars["color_" + tint + "_background"],
    })
  ],
  ["color_" + tint + "_border"]: (selector, vars) => [
    sel(selector, {
      ".pe-toolbar--border": {
        borderColor: vars["color_" + tint + "_border"]
      }
    })
  ]
});

const lightTintFns = Object.assign({}, generalFns, tintFns("light"));
const darkTintFns = Object.assign({}, generalFns, tintFns("dark"));

export default createColor({
  varFns: { lightTintFns, darkTintFns }
});
